arch snes.cpu

LoROM

//==================================================================================================================================
// Insert new "MISS" battle sprite, the alternate gfx patch moved it to a new location in the expanded ROM and enhanced its bpp
org $26e380
incbin bin/graphics-battle-miss-alt.bin




//==================================================================================================================================
// Specific enemy fixes, mostly to unglitch graphics that were messed up in the original Japanese gfx enhancement patch

// make the Leap Frog look correct, the original Japanese enemy enhancement patch is glitched
org $fcd10; db $00,$da,$10,$80

// makes the Black Dragon boss appear properly, wasn't sure which palette to give it so just gave it an existing dark one
org $fccd4; db $04,$7b,$20,$96

// makes the Toady Witch display properly instead of glitched
org $fcbf0; db $02,$9e,$60,$86

// fixes Shinryu stuff
org $fcd59; db $81  // fixes palette, guessed on which it should be, chose my favorite
org $e87a5; db $03  // fixes position in battle to be more centered

// fixes Golbez's palette, although it's not the correct one - I don't think the proper palette exists in the original gfx patch
org $fcecf; db $a9    // a5 and bc are also kinda cool

// modifies the Black Dragon boss to look better and to match the summon sprite
org $fccd4; db $04,$03,$80,$99    // reassign sprite used by Black Dragon and give appropriate palette
org $e877d; db $70                // put the Black Dragon in a better looking formation
org $e877f; db $00                // assign an appropriate cursor type, although this isn't really needed in this case

// fixes programmer battle gfx + assigns new palettes
org $fcd5c; db $01,$ad,$40,$c0   // K. Higuchi, technically, $ad might not be a valid palette but it works for our needs
org $fcd6c; db $02,$7c,$e0,$87   // K. Aoki
org $fcd68; db $00,$ae,$00,$80   // A. Matsui
org $fcd74; db $04,$4d,$60,$98   // K. Yoshii
org $fcd70; db $04,$94,$d0,$97   // H. Nakada
org $fcd78; db $01,$b6,$c0,$84   // Takahashi
org $fcd64; db $04,$37,$e0,$c0   // H. Itou


//==================================================================================================================================
// Fixes battle formation problems in the original Japanese enhancement gfx patch
// The biggest problem involved resized enemies overlapping each other, making things look weird
// Other times, resized enemies appeared too high on the screen or too low, so that they overlapped/went behind the menus
// In some cases I've also added the floating shadow animation beneath enemies when appropriate, but this doesn't affect their weaknesses

// Group 0x05: 2 bighorn, 2 goblin
org $e802d; db $08
org $e802f; db $09

// Group 0x14: 4 gigantoad
org $e80a5; db $0b
org $e80a7; db $0c

// Group 0x15: 2 gigantoad, 2 poisontoad
org $e80ad; db $0b
org $e80af; db $0c

// Group 0x1a: 4 poisontoad
org $e80d5; db $0b
org $e80d7; db $0c

// Group 0x1d: 1 bighorn, 2 goblin, 2 stunner
org $e80ed; db $05
org $e80ef; db $06

// Group 0x2b: 4 balloon
org $e815d; db $00
org $e815f; db $01

// Group 0x37: 2 bighorn, 2 tusk rhino
org $e81bd; db $19
org $e81bf; db $08

// Group 0x39: 3 cockatrice
org $e81cd; db $28
org $e81cf; db $22

// Group 0x3a: 2 bighorn, 2 tusk rhino
org $e81d5; db $8e
org $e81d7; db $58

// Group 0x4b: 3 flyinfrenzy, 2 gigantbird
org $e825d; db $10
org $e825f; db $06

// Group 0x4c: 1 viol.shark, 2 gigantbird
org $e8265; db $02
org $e8267; db $03

// Group 0x50: 1 sea snake, 3 gigantbird
org $e8285; db $19
org $e8287; db $08

// Group 0x58: 2 death horn, 2 ochu
org $e82c5; db $19
org $e82c7; db $08

// Group 0x59: 1 werepanther, 2 death horn
org $e82cd; db $18
org $e82cf; db $14

// Group 0x5b: 1 malboro, 2 death horn
org $e82dd; db $18
org $e82df; db $14

// Group 0x5d: 2 ogre
org $e82ed; db $09
org $e82ef; db $0a

// Group 0x64: 1 draculass, 3 death ray, ADDED FLOATING ANIMATION
org $e8325; db $1f
org $e8326; db $40
org $e8327; db $1b

// Group 0x67: 2 water naga, 2 malboro
org $e833d; db $19
org $e833f; db $08

// Group 0x68: 2 draculass, 3 death ray, ADDED FLOATING ANIMATION
org $e8345; db $2b
org $e8346; db $40
org $e8347; db $06

// Group 0x6e: 2 deathknight, 2 sea dragon
org $e8375; db $19
org $e8377; db $08

// Group 0x72: 1 ice lizard, 3 green slime
org $e8395; db $07
org $e8397; db $08

// Group 0x75: 2 buccaneer, 2 ice lizard
org $e83ad; db $0b
org $e83af; db $0c

// Group 0x77: 1 gottos, 2 ice lizard
org $e83bd; db $07
org $e83bf; db $08

// Group 0x78: 2 gottos, 2 ice lizard
org $e83c5; db $0b
org $e83c7; db $0c

// Group 0x81: 1 ogre mage, 2 killmantis
org $e840d; db $02
org $e840f; db $03

// Group 0x91: 2 twinbie, 2 salamander
org $e848d; db $19
org $e848f; db $08

// Group 0x9a: 4 ogre chief
org $e84d5; db $19
org $e84d7; db $08

// Group 0x9f: 2 ogre chief, 2 coeurl
org $e84fd; db $19
org $e84ff; db $08

// Group 0xa8: 1 ogre chief, 1 coeurl, 2 mine
org $e8545; db $19
org $e8547; db $08

// Group 0xac: 3 mine, 1 stalactite
org $e8565; db $19
org $e8567; db $08

// Group 0xad: 2 stalactite, 1 lamia
org $e856d; db $0b
org $e856f; db $0c

// Group 0xaf: 1 coeurl, 1 black knight, 1 ogre chief
org $e857d; db $07
org $e857f; db $08

// Group 0xb7: 1 mother lamia, 3 eggs
org $e85bd; db $19
org $e85bf; db $08

// Group 0xb9: 1 eyemoeba, 2 mech soldier, 1 mech soldier (summoned)
org $e85cd; db $5e
org $e85cf; db $3d

// Group 0xbc: 1 eyemoeba, 2 mech soldier, 1 black knight (summoned)
org $e85e5; db $5e
org $e85e7; db $3d

// Group 0xc8: 1 eyemoeba, 2 guardian, 1 allosaurus (summoned)
org $e8645; db $5e
org $e8647; db $3d

// Group 0xcb: 1 mythril golem, 2 black knights
org $e865d; db $07
org $e865f; db $08

// Group 0xcf: 2 mythril golem
org $e867d; db $02
org $e867f; db $03

// Group 0xd1: 6 bighorn
org $e868d; db $08
org $e868f; db $09

// Group 0xd2: 2 fire hydra, 2 salamander
org $e8695; db $19
org $e8697; db $08

// Group 0xd7: 2 black knights
org $e86bd; db $01
org $e86bf; db $01

// Group 0xd8: 1 mythril golem, 2 black knights
org $e86c5; db $02
org $e86c7; db $03

// Group 0xf7: 5 pirate
org $e87bd; db $56
org $e87bf; db $37

// Group 0xf8: 1 werepanther, 1 sergeant, 1 hydra
org $e87c5; db $07
org $e87c7; db $08

// Group 0x102: 3 goblin prince, 1 dual head, 1 salamander
org $e8815; db $05
org $e8817; db $06

// Group 0x106: 2 land turtle, 1 dual head, 1 salamander
org $e8835; db $07
org $e8837; db $08

// Group 0x10d: 1 captain, 2 fire hydra
org $e886d; db $02
org $e886f; db $03

// Group 0x10e: 2 captain, 2 fire hydra
org $e8875; db $19
org $e8877; db $08

// Group 0x113: 2 land turtle, 2 salamander
org $e889d; db $07
org $e889f; db $08

// Group 0x115: 6 white mousse
org $e88ad; db $13
org $e88af; db $0f

// Group 0x116: 1 chimera, 3 white mousse
org $e88b5; db $07
org $e88b7; db $08

// Group 0x11d: 2 medusa
org $e88ed; db $0a
org $e88ef; db $0b

// Group 0x11e: 2 wood golem
org $e88f5; db $02
org $e88f7; db $03

// Group 0x129: 1 mother lamia, 3 egg
org $e894d; db $19
org $e894f; db $08

// Group 0x12b: 1 mother lamia, 3 egg
org $e895d; db $19
org $e895f; db $08

// Group 0x12d: 2 mythril golem
org $e896d; db $02
org $e896f; db $03

// Group 0x12e: 1 mythril golem, 2 black knight
org $e8975; db $02
org $e8977; db $03

// Group 0x131: 1 mythril golem, 2 coeurl
org $e898d; db $02
org $e898f; db $03

// Group 0x135: 2 stalactite, 2 black knight
org $e89ad; db $05
org $e89af; db $06

// Group 0x148: 2 yellow soul, 2 neochu
org $e8a45; db $17
org $e8a47; db $16

// Group 0x149: 2 neochu, 1 land marlboro, 1 yellow soul
org $e8a4d; db $07
org $e8a4f; db $08

// Group 0x14b: 2 neochu, 2 land marlboro
org $e8a5d; db $19
org $e8a5f; db $08

// Group 0x15a: 1 wyrm, ADDED FLOATING ANIMATION
org $e8ad5; db $70
org $e8ad6; db $40
org $e8ad7; db $00

// Group 0x15b: 2 wyrms, ADDED FLOATING ANIMATION ONLY!
org $e8add; db $02
org $e8ade; db $40
org $e8adf; db $03

// Group 0x162: 1 draculady, 3 flying ray, ADDED FLOATING ANIMATION
org $e8b15; db $1f
org $e8b16; db $40
org $e8b17; db $1b

// Group 0x164: 2 draculady, 3 flying ray, ADDED FLOATING ANIMATION
org $e8b25; db $2b
org $e8b26; db $40
org $e8b27; db $06

// Group 0x169: 1 stalagmite, 1 spirit naga
org $e8b4d; db $01
org $e8b4f; db $01

// Group 0x16d: 1 gorgomera, 2 spirit naga
org $e8b6d; db $07
org $e8b6f; db $08

// Group 0x18e: 2 blue dragon
org $e8c75; db $41
org $e8c77; db $02

// Group 0x1c4: 4 ogre chief
org $e8e25; db $19
org $e8e27; db $08

// Group 0x1d8: 1 demon flower, 2 hornet, 2 round worm
org $e8ec5; db $09
org $e8ec7; db $0a

// Group 0x1ed: 1 soul flayer, 2 draculord
org $e8f6d; db $00
org $e8f6f; db $01

// Group 0x1ef: 2 blue dragon
org $e8f7d; db $41
org $e8f7f; db $02





//23e060 is start of desired black dragon palette


// d87f0 has pointers to be used by golbez summon, d8 ee in original hack

org $26a200; incbin bin/graphics-golbez-summon.bin
org $23ffc0; incbin bin/graphics-golbez-summon-palette.bin
org $d87f0; dw $0001   // our special pointer that will indicate Golbez is being summoned
org $dfe4c; db $fe     // we're assigning a crazy palette number that hopefully isn't already taken

// We're reusing the sea snake sprite from the enhanced gfx patch for the black dragon, so no need for new gfx
org $d87f6; dw $0002   // our special pointer that will indicate the Black Dragon is being summoned
org $dfe4f; db $03     // assign an appropriate palette to the Black Dragon sprite

org $2eaa6; jsl load_custom_summon_graphics

org $26a000 
db "****************GRAPHICS: FIXED GOLBEZ & BLACK DRAGON GFX, BROKEN IN JPN ENHANCEMENT PATCH"

load_custom_summon_graphics:
cpy #$0001
beq load_golbez_gfx
cpy #$0002
beq load_blackdragon_gfx

load_normal_gfx:
sep #$20
lda #$24
rtl

load_golbez_gfx:
sep #$20
lda #$26
ldy #$a200
rtl

load_blackdragon_gfx:
sep #$20
lda #$21
ldy #$cc00
rtl

// dfe4f seems to be palette for black dragon




