//====================================================================
// DISPLAY CUSTOM INTRO SCREEN BEFORE TITLE SCREEN LOADS
//====================================================================

org $8021; jml display_intro_screen




//-----------------------------------------------------------------------------
// GRAPHICS-RELATED STUFF
//-----------------------------------------------------------------------------

// Insert custom intro screen font (taken from Ys III for some system)
org $28b410; incbin bin/graphics-intro-font.bin

// Insert custom intro screen palette
org $28d000
db $00,$00,$00,$20,$ce,$39,$ff,$7f,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$70   // main text palette
db $00,$00,$00,$20,$ce,$39,$ff,$0f,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$70   // yellow text palette




//-----------------------------------------------------------------------------
// NEW EXPANDED AREA CODE
//-----------------------------------------------------------------------------

org $28b000
db "****************NEW ASM & GRAPHICS: CUSTOM INTRO SCREEN"

// much of this code was originally written by DaMarsMan as seen in
// the online document "Adding an SNES Intro (with a few clicks)"
display_intro_screen:
lda #$80
sta $2100
lda #$00
sta $2101
sta $2102
sta $2103
sta $2105
sta $2106
sta $2107
sta $2108
sta $2109
sta $210a
sta $210b
sta $210c
sta $210d
sta $210d
sta $210e
sta $210e
sta $210f
sta $210f
sta $2110
sta $2110
sta $2111
sta $2111
sta $2112
sta $2112
sta $2113
sta $2113
sta $2114
sta $2114

lda #$80
sta $2115
lda #$00
sta $2116
sta $2117
sta $211a
sta $211b
lda #$01
sta $211b
lda #$00
sta $211c
sta $211c
sta $211d
sta $211d
sta $211e
lda #$01
sta $211e
lda #$00
sta $211f
sta $211f
sta $2120
sta $2120
sta $2121
sta $2123
sta $2124
sta $2125
sta $2126
sta $2127
sta $2128
sta $2129
sta $212a
sta $212b
lda #$01
sta $212c
lda #$00
sta $212d
sta $212e
sta $212f
lda #$30
sta $2130
lda #$00
sta $2131
lda #$e0
sta $2132
lda #$00
sta $2133
lda #$01	// auto read joypads
sta $4200
lda #$ff
sta $4201
lda #$00
sta $4202
sta $4203
sta $4204
sta $4205
sta $4206
sta $4207
sta $4208
sta $4209
sta $420a
sta $420b
sta $420c
sta $420d
rep #$30
sep #$20
lda #$00   // set bg mode 0
sta $2105
lda #$01
sta $212c

jsl clear_tilemap

ldx #$1000
stx $2116
ldx #$1801
stx $4300

ldx #$b400  // set offset to our custom font
stx $4302
lda #$28    // set bank

sta $4304
ldx #$1000
stx $4305
lda #$01
sta $420b


// copy tilemap to VRAM
ldx #$0000      // target address in vram
stx $2116
lda #$28        // SRCBANK
ldx #$c400      // SRCOFFSET
ldy #$0800      // SIZE

stx $4302   // Store Data offset into DMA source offset
sta $4304   // Store data Bank into DMA source bank
sty $4305   // Store size of data block

lda #$01
sta $4300   // Set DMA mode (word, normal increment)
lda #$18    // Set the destination register (VRAM write register)
sta $4301
lda #$01    // Initiate DMA transfer (channel 1)
sta $420B


// copy palette to VRAM
// we're using the existing palette used by the title screen
// and we only care about the text being white, so we don't need
// to load everything. Basically this is a really hacky way to
// make it work but as long as it works I'm cool with it
lda #$00
sta $2121       // Start at specified color
lda #$28        // specify source address
ldx #$d000
ldy #$0032      // 2 bytes for every color

stx $4302   // Store data offset into DMA source offset
sta $4304   // Store data bank into DMA source bank
sty $4305   // Store size of data block

stz $4300  // Set DMA Mode (byte, normal increment)
lda #$22    // Set destination register ($2122 - CGRAM Write)
sta $4301
lda #$01    // Initiate DMA transfer
sta $420B


lda #$00
sta $2107
lda #$01
sta $210b

ldx #$0004
jsl wait_around
jsr Jump1



Jump9:
sta $2100
inc
ldy #$1fff
jsr Jump2

cmp #$10
bcc Jump9



// ===== start fade routine
cli
ldx #$0030

Jump3:
sep #$20
ldy #$ffff

Jump4:
dey
bne Jump4

Jump5:
lda $4212
and #$80
beq Jump5

Jump6:
lda $4212	// check vblank
and #$01
bne Jump6

rep #$20
lda $4218
and #$f0f0
bne Jump7
dex


//bne Jump3 // don't wait for keypress
bra Jump3   // wait for keypress

Jump7:
sep #$20
lda $4210
and #$80
beq Jump7
lda #$0f

Jump10:
sta $2100
dec
pha
jsr Jump2
// ===== end fade routine


pla
cmp #$00
bne Jump10


ldx #$0600  // original overwritten code
phx
jml $008025


//-------------------------------------------------------------------

Jump1:
pha
Jump11:
lda $4210
and #$80
beq Jump11
pla
rts


//-------------------------------------------------------------------
Jump2:
//ldy #$ffff
Jump8:
dey
bne Jump8
rts

//-------------------------------------------------------------------
vblank:
pha
php
sep #$20

Vloop:
lda.l $4210
and #$80
beq Vloop

plp
pla
rts


//-----------------------------------------------------------------------------
clear_tilemap:
rep #$20
lda #$beef
ldx #$0000

-
stx $2116
sta $2118  // write 0000 to current address in vram

inx        // move to next byt in vram
cpx #$0400
bcc -

lda #$0000
sep #$20
rtl



wait_around:
ldy #$ffff
-
dey
cpy #$0000
bne -

dex
cpx #$0000
bne wait_around

rtl







