//====================================================================
// FF4 LEGEND DISPLAY MODIFICATIONS, DESIGNED FOR FF2C HACK BUT SHOULD
// WORK ON ORIGINAL FF4J TOO (mysidian legend, not outer space legend)
//====================================================================
// modify intro legend text to allow for longer text
// note that the original legend can only be 8 lines long. This limitation is
// due to SFC tilemaps only allowing for 8 different palette IDs. they must've
// reprogrammed the entire legend sequence for FF2us.
//
// To allow for more than 8 lines, we need to turn off the line-by-line fade
// and fade all the text in at once. It's not ideal, but it also gets around
// the problem of trying to figure out how to speed up the individual line
// fades, which we can't do anyway if we want over 8 lines, which we do here.
//
// Note that my modifications to expand the main dialogue window text affects
// the text here too, meaning lines can be 26 letters long, EXCEPT when a
// line number is a multiple of 4. If a line number is a multiple of 4 and
// the max number of letters is used, it will generate a line break for the
// following line automatically. This isn't necessarily bad but probably not
// what most people would expect or intend. It could be used to a writer's
// advantage though, if used cleverly.
//
// I also modified the fade routine to go from blue to white instead of blue
// to yellow.


//-----------------------------------------------------------------------------
// IMPORTANT INITIAL VALUES

org $c869; db $04    // number of lines in legend to fade in, but in our case
                     // this is basically just a timer for the scene to end
org $c81a; db $f8    // move legend text up, $f8 goes to the top


//-----------------------------------------------------------------------------
// Allow for 4 more lines in the legend
org $c7c6
jsr $b45b
inc $ed
jsr $b80f
jsl extend_legend_1
nop; nop; nop; nop; nop; nop


//-----------------------------------------------------------------------------
// Make all the lines in the legend fade in at once
org $c7e2
lda #$0020


//-----------------------------------------------------------------------------
// NOP most of the original text fading routine, then redirect to our custom
// fade-in code
org $c838; fill $2A,$EA
org $c838
jsl extend_legend_2




//====================================================================
// NEW CUSTOM CODE GOES HERE
//====================================================================
org $2BF000
db "****************NEW CODE: FFIIc LEGEND MODIFICATIONS"

//-----------------------------------------------------------------------------
// We needed to insert some extra code into the original programming to allow
// for four extra lines, so the original code got relocated here
extend_legend_1:
stz $dd
stz $ed
lda #$80
sta $2115
ldx #$2C00
stx $2116
ldx #$0000
rtl


//-----------------------------------------------------------------------------
// The original palette fade code was relocated here, and then modified to
// go from blue to white rather than yellow. To simplify this, I generated a
// 512-byte palette data that the routine loads from. I could've had it
// calculate everything on the fly, but this was simpler
extend_legend_2:
sep #$20
lda $2e
cmp #$00
bne +

rep #$20
lda $20
asl
tax
lda legend_fade_palette_data,x
sta $22
sta $0ce1

+
rep #$20
lda #$0000
sep #$20
inc $20
rtl


//-----------------------------------------------------------------------------
legend_fade_palette_data:
incbin bin/legend-fade-palette.bin