//====================================================================
// MAIN MENU MODIFICATIONS
//====================================================================

//-----------------------------------------------------------------------------
// GENERAL CHANGES
//-----------------------------------------------------------------------------

org $2AC000; db "****************NEW TEXT: ITEM DESCRIPTION POINTERS"
org $2AC240; db "****************NEW TEXT: ITEM DESCRIPTION STRINGS"

org $2f8000; db "****************NEW TEXT: MENU TEXT POINTERS"
org $2f8200; db "****************NEW TEXT: MENU STRINGS&LAYOUT"


//-----------------------------------------------------------------------------
// Changes default background color to be different from vanilla FF4
// this is unnecessary of course, but I feel it's a small tweak that matches
// the idea of the hack
org $19b26; dw $4020


//-----------------------------------------------------------------------------
// realign menu cursor to look better
org $1881b; db $0e


//-----------------------------------------------------------------------------
// allows SAVE to be fully lit up in main menu
org $18939
jsl mainmenu_save_highlight
nop; nop; nop; nop; nop; nop; nop; nop; nop; nop




//-----------------------------------------------------------------------------
// POST-BATTLE TREASURES MENU
//-----------------------------------------------------------------------------

org $1e271
db $16,$00            // moving "Take All/End" window slightly
db $11,$02            // resize window to fit properly
db $02,$01            // move down dropped item window by 1 tile
db $1b,$09            // shorten dropped item window by 1 tile
db $02,$00            // move "otakara" box
db $08,$02            // lengthen "otakara" box
db $04,$00            // move "otakara" text

org $1d88c; db $58    // move left cursor xpos for Treasure menu
org $1d890; db $B0    // move right cursor xpos for Treasure menu




//-----------------------------------------------------------------------------
// MAIN MENU: GIL & TIME-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

org $18925; nop; nop; nop; nop; nop; nop  // remove original "Gil" window

org $1db6c; db $07      // resize time/gil window

org $187d2; dw $05ee    // move "Gil" string up and left a bit
org $187db; dw $066c    // move gil

org $187c9; dw $056e    // move  "Time" string on main menu
org $18bc4; dw $05b8    // move numerical time on main menu
org $18bc8; dw $05ba
org $18bd6; dw $05b0
org $18bdb; dw $05b2
org $18be0; dw $05b4
org $18be5; dw $05b6




//-----------------------------------------------------------------------------
// MAIN MENU: CHARACTER DISPLAY-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

org $18b33; nop; nop   // remove job class names from various screens BUT retain status icons if any are present

org $189fb; db $0a     // move the numerical level stat left on main menu for each character
org $189ff; db $0c          

org $189c8; fill $10,$EA    // NOP most of the code that manually writes out "LEVEL" on the main menu
org $189c8                  // and now we're just going to have it say "LV"
lda #$57
sta $0002,x




//-----------------------------------------------------------------------------
// EQUIPMENT MENU-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

// move all equip names right 2 tiles in Equip menu
org $1bd93; dw $0068
org $1bda9; dw $00e8
org $1bd7c; db $0168
org $1bd83; db $01e8
org $1bd8a; db $0268
org $1be1f; db $58    // move cursor left 1 tile
org $1be1b; db $0e    // make cursor better vertically align with body part names
org $1bd46; dw $a68e  // move equip screen stat numbers left
org $1bd4b; dw $a70e
org $1bd50; dw $a78e
org $1bd28; dw $008e
org $1bd33; dw $010e
org $1bd3e; dw $018e

org $1bd71; dw $0246 // move handedness string left one tile in equip menu
org $1bd68; dw $800a // we want longer "handedness" names in the equip menu, so we have to repoint the strings
org $1bd5e; jsl expand_equip_handedness; nop

org $1b0ed; dw $0250      // move the "MP Cost" string in the main magic menu
org $1b0e7; dw $0262      // move the MP cost number in main magic menu
org $1b0f7; nop; nop; nop // remove the original "..." between the above two strings
org $1b04c; dw $0250      // make the newly moved mp cost string + number get erased properly
org $1b04f; db $0b        // number of tiles to clear from the above data when closing the magic menu
org $1b41a; dw $0006      // correct the graying-out/highlighting of spell categories in main magic menu
org $1b0cc; jsl adjust_magic_category_cursor




//-----------------------------------------------------------------------------
// STATS WINDOW-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// resize main "Stats" window in transition
org $1de05; dw $01ac,$0307


//-----------------------------------------------------------------------------
// Reorganize all the data on the status window, the original game's layout
// wasn't very good IMO
org $1a990; dw $1810     // move character portrait to a diff part of screen
org $1a9b8; dw $008e     // move character name
org $1aad5; dw $010e     // move class/job name
org $1aaca; dw $014e     // move handedness
org $1a9be; dw $008e     // move affliction icons
org $1a9cb; dw $034e     // move level number
org $1aa73; dw $0394     // move max HP number
org $1aa68; dw $038a     // move curr HP number
org $1aa89; dw $03d4     // move max MP number
org $1aa7e; dw $03ca     // move curr MP number
org $1abf3; dw $b992     // move HP slash mark
org $1abf6; dw $b9d2     // move MP slash mark
org $1aa5b; dw $03aa     // move exp number
org $1ab67; dw $03ea     // move exp to next level number
org $1a9d6; dw $044e     // move STR number
org $1a9e1; dw $048e     // move AGI number
org $1a9ec; dw $04ce     // move VIT number
org $1a9f7; dw $050e     // move WIS number
org $1aa02; dw $054e     // move WIL number
org $1aa2e; dw $04b6     // move accuracy number
org $1aa39; dw $0576     // move evasion number
org $1aa44; dw $0636     // move mag.evade number
org $1aa0d; dw $046e     // move ATK times number
org $1aa18; dw $052e     // move DEF times number
org $1aa23; dw $05ee     // move Mag.DEF  times number
org $1aa98; dw $0472     // move ATK number
org $1aaa3; dw $0532     // move DEF number
org $1aaae; dw $05f2     // move Mag.Def number
org $1abe8; dw $baba     // move accuracy % mark
org $1abeb; dw $bb7a     // move evasion % mark
org $1abee; dw $bc3a     // move mag. evasion % mark
org $1abc2; fill $23,$EA // remove all the "..."s from the Status window


//-----------------------------------------------------------------------------
// Display our custom character descriptions, not in original Japanese hack
org $1aa91; jmp add_character_description


//-----------------------------------------------------------------------------
// load our custom class strings for status window
org $2e8000; db "****************NEW TEXT: EXTENDED CLASS NAMES"

// let the game know where to find our custom strings
org $18fe3; lda $2e8030,x
org $18fd0; fill $13,$EA
org $18fd0
lda #$0000
sep #$20
pla
asl
asl
asl
asl
tax
sep #$20
lda #$10
sta $45


//-----------------------------------------------------------------------------
// allow the status screen to use full length handedness strings
org $1aab7; jsl expand_equip_handedness; nop
org $1aac1; dw $8034


//-----------------------------------------------------------------------------
// when printing a numeral out, don't print the 3rd and 4th digit if they're blank
org $18394; fill $14,$EA
org $18394; jsl numeral_print_modification




//-----------------------------------------------------------------------------
// CONFIG MENU-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

org $1e15c; dw $004a,$0214   // resize the box around "Config", also applies to "Customizer" box
org $1d1cf; dw $0220         // move top row of "1 2 3 4 5 6" text
org $1d1c6; dw $02a0         // move bottom row of "1 2 3 4 5 6" text
org $1d77a; dw $b821         // move graying of top number line
org $1d780; dw $b8a1         // move graying of bottom number line
org $1d223; dw $b821         // move highlighting of top number line
org $1d230; dw $b8a1         // move highlighting of bottom number line

org $1d1b9; dw $bb20         // move "R"
org $1d1be; dw $bba0         // move "G"
org $1d1c3; dw $bc20         // move "B"
org $1d1db; dw $bb24         // move R bar
org $1d1e1; dw $bba4         // move G bar
org $1d1e7; dw $bc24         // move B bar
org $1d253; db $8e           // move R tick
org $1d261; db $8e           // move G tick
org $1d26f; db $8e           // move B tick

org $1d248; db $00           // move main cursor starting x-pos
org $1d23b; db $2e           // move main cursor starting y-pos
org $1d626; db $70           // move inner cursor starting x-pos
org $1d622; db $b0           // move inner cursor secondary x-pos
org $1d20f; db $2e           // move inner cursor starting y-pos

org $1d2a3; db $5e           // move "Sound" cursor y-pos
org $1d2b1; db $6e           // move "Controller" cursor y-pos
org $1d202; db $7e           // move "single/multie" cursor y-pos
org $1d2bf; db $8e           // move "Cursor Pos." cursor y-pos


//-----------------------------------------------------------------------------
// Control customizer screen stuff
org $1e200; dw $0140,$121d   // move Customizer options box and resize
org $1d4a9; dw $0198         // move top "A B X Y" string
org $1d4b2; dw $0218         // move middle "A B X Y" string
org $1d4bb; dw $0298         // move bottom "A B X Y" string
org $1d494; dw $038a         // move top "Off  Accept  Cancel  Menu" string
org $1d49d; dw $044a         // move bottom "Off  Accept  Cancel  Menu" string

org $1d4e7; db $04           // move main cursor x-pos
org $1d4de                   // calculate our new, modified main cursor y-pos
jsl customizer_cursor_calculator;
nop
nop

org $1d614; db $54,$6c,$84,$9c,$b4  // move x-pos of "A B X Y" cursors
org $1d619; db $1c,$44,$84,$c4      // move x-pos of bottom "Off Accept Cancel Menu" cursors
org $1d4f7; db $3a                  // move y-pos of all secondary customizer cursors
org $1d504; db $4a
org $1d511; db $5a
org $1d527; db $7a
org $1d53d; db $92


//-----------------------------------------------------------------------------
// Character/controller selector screen stuff
org $1d6c8; db $3a    // move cursor up
org $1d6cc; db $20    // move cursor left
org $1d66a; dw $018c  // move names up and left
org $1d6ef; dw $a584  // move controller number right
org $187b9; jsl controller_choice_formatter1
org $187bd; jsl controller_choice_formatter2




//-----------------------------------------------------------------------------
// FILE SAVE/LOAD MENU-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

// Save/load file menu stuff
org $1dfdc; dw $002a,$0909   // move and resize "Save over existing file?" box
org $1987b; db $2e           // move "Save over existing?" -> "yes/no" cursor y-pos, first selection
org $19877; db $3e           // move above cursor y-pos, second selection
org $1987f; db $b0           // move above cursor left
org $1e050; dw $02ea,$0209   // move and resize the "Saved!" box
org $19904; db $5e           // move main character sprite after "New Game" right a tiny bit
org $19851; dw $0676         // move "Gil" on "load this file?" screen left a little
org $19a63; dw $00ca         // move save slot # right one, any further seems to be problematic to fix




//-----------------------------------------------------------------------------
// ITEM MENU-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

// item menu stuff
org $1a11d; db $00           // move left column cursor x-pos
org $1a11a; db $70           // move right column cursor x-pos

org $1dcd6; dw $0010,$0314 // move and resize item description window in main item menu
org $1dcd4; dw $0306       // fix problem with "Item" minibox when it needs to be refreshed
org $1dcfe; dw $0305       // same as above
org $1dcdc; dw $030e       // resize "Not needed" window


//-----------------------------------------------------------------------------
// allow item descriptions for basically any item except 0x00, 0xFE and 0xFF
org $1a7e3; db $01 // disable description for item 0
org $1a7e7; db $fe // disable description for item 0xfe and 0xff
org $1a7eb; nop; nop;
org $1a7f0; fill $17,$EA
org $1a7f0; jsl item_description_handler

org $1a808
lda #$2a   // set bank the item description is stored in
ldx #$0012 // set starting position of item description in window

org $18325 // stop dakuten stuff from being accounted for in menus
nop; nop; nop; nop; 




//-----------------------------------------------------------------------------
// MAGIC MENU-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// short spell names in menus
org $1b322; dw $0000
org $1b32b; jsl loadshortspellname_menu1
org $1b349; jmp loadshortspellname_menu2a


//-----------------------------------------------------------------------------
// misc. formatting stuff
org $1dd77; dw $0607       // resize "spell + mp cost" box in main menu casting window
org $1dd71; dw $01c2       // move "Use on whom?" box in main menu casting window
org $1b4c0; dw $014c       // move MP cost number in main menu casting window




//-----------------------------------------------------------------------------
// SHOP MENU-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

org $1deae; dw $0002,$0309   // move and resize shop type window
org $1c34b; dw $0044         // move shop type text left one tile
org $1deb2; dw $0018,$0310   // move and resize "Welcome!" window
org $1dea6; dw $0162,$020b   // move and resize Gil owned window
org $1deaa; dw $0142,$020e   // move and resize "buy sell exit" window
org $1deb6; dw $0242,$1114   // move and resize big item window in shop menu

org $1c563; dw $002e         // move "Gil" in item prices right one tile
org $1c3f6; dw $01e2         // move Gil owned numeral down and left
org $1c310; dw $60c0         // move character sprites in shop menu down a little
org $1c465; dw $01da         // move the "10" numeral in the "how many?" buy box
org $1c65a; dw $01da         // move another "10" numeral in the "how many?" buy box
org $1c81f; dw $01da         // move the "10" numeral in the "how many?" sell box
org $1c9f4; dw $040e         // move total sell price to a different position in "is this okay to sell?" window
org $1c9d8; dw $036a         // move "sell x" numeral in sell confirmation window

org $1cb18; dw $3640         // initial y,x position of "how many" buy cursor
org $1cb13; dw $3658         // secondary y,x position of "how many" buy cursor
org $1c811; dw $3640         // initial y,x position of "how many" sell cursor
org $1c80c; dw $3658         // secondary y,x position of "how many" sell cursor
org $1c5bd; db $56           // move cursor y-pos for item list in shop menu
org $1c5c1; db $08           // move cursor x-pos for item list in shop menu
org $1ca22; db $50           // move initial cursor x-pos for sell confirmation window
org $1ca26; db $78           // move secondary cursor x-pos for sell confirmation window
org $1ca1a; db $a6           // move cursor y-pos for sell confirmation window

org $1c862; db $00           // move left column cursor x-pos in sell window
org $1c85e; db $70           // move right column cursor x-pos in sell window
org $1c855; db $56           // move cursor y-pos up a tad in sell window


//-----------------------------------------------------------------------------
// move items in buy window down
org $1c58e
dw $0286,$0306,$0386,$0406,$0486,$0506,$0586,$0606         


//-----------------------------------------------------------------------------
// move prices in buy window down
dw $02d6,$0356,$03d6,$0456,$04d6,$0556,$05d6,$0656


//-----------------------------------------------------------------------------
org $1c389; db $08    // move Buy/Sell/Exit cursor left
org $1c38d; db $36    // move Buy/Sell/Exit cursor down

// recalculate cursor x-pos in "buy/sell/exit" window
org $1c37f; fill $0B,$EA  // nop out existing code
org $1c37f
jsl shop_cursor_calculator


//-----------------------------------------------------------------------------
// Make shop names use our custom menu text
org $1c33c; fill $0C,$EA  // nop existing code
org $1c33c
asl         // multiply shop type by 2
rep #$20
clc
adc #$8074  // signals our custom menu code
tay


//-----------------------------------------------------------------------------
// Centering the item name to be sold + using the long name
org $1c9d7; fill $2E,$EA
org $1c9d7
jsl display_item_being_sold
lda $60  // this was originally 5e but that number seems to be the max sellable and not the amount selected
jsr $8369

rep #$20
lda #$0000
-
clc
adc $5a
bcc +
inc $39
+
dec $60
bne -

sta $37
lda $39
ldx $37
ldy #$040e
sep #$20
jsr $8fa6




//-----------------------------------------------------------------------------
// FAT CHOCOBO MENU-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

org $1e0d4; dw $004c,$0216   // move and resize Fat Chocobo dialog box
org $1cdb9; dw $3E08         // move initial main cursor x and y position
org $1cdb4; dw $3e50         // move second main cursor x and y position

org $1cdc5; dw $338e         // move character sprites & squish them closer together
org $1ceb5; dw $338e
org $1937b; dw $0014
org $19380; dw $0014
org $19385; dw $0014
org $1938a; dw $0014




//-----------------------------------------------------------------------------
// NAMINGWAY MENU-RELATED MODIFICATIONS
//-----------------------------------------------------------------------------

org $1baf4; dw $2594            // move party member sprites to the right a little

org $1ba4e; dw $0186            // move "Change  Don't Change" text to the left a little
org $1ba7c; dw $2E08            // move initial "Change Don't Change" cursor x and y pos
org $1ba81; dw $2e48            // move secondary"Change Don't Change" cursor x and y pos

org $1e0d0; dw $0114,$0206      // move the character name window to the right a little
org $1bb3e; dw $0156            // move character name text to the right a little
org $19e91; dw $0156            // move character name text to the right a little while editing name

org $1db59; dw $0200,$1105      // move, reposition the "Katakana", "ABC", etc. sidebar window
org $1db5d; dw $020e,$1116      // move, reposition big window full of letters
org $19d63; db $04              // move letter category cursor's x-pos
org $1dcaa; db $4e,$5e,$6e,$be  // move letter category cursor's y-positions

// overwrite existing naming screen letter chart with our custom one
org $1dbba; incbin bin/naming-screen-layout.bin




//-----------------------------------------------------------------------------
// CUSTOM MENU TEXT SYSTEMS
//-----------------------------------------------------------------------------
// To fully expand and resize menu stuff as needed, I devised a hacky solution
// that basically involves turning string addresses into "string IDs" if the
// value is near 0x8000.


//-----------------------------------------------------------------------------
// used to divert menu data setup calls to enable our expanded banks
// most menu data is stored in bank 0x01 but our custom stuff will be stored in 0x2E
org $1fff8
preploadwindow:
jsl loadwindow
rts


//-----------------------------------------------------------------------------
// Connect our custom menu text/data loaders to the game's original code

org $18307; jsr preploadwindow; nop              // this is used to set up our hacks for menu-related data & text
org $180d9; jml custom_menu_window_reader        // this is used to build windows from the data before some menu strings
org $182d4; jml custom_menu_text_reader2; nop    // this is used for plain text strings without any extra data
org $1879b; jsl custom_menu_text_reader3         // also used for some simple plain strings



//-----------------------------------------------------------------------------
// Menu data redirects, this works together with the new "loadwindow" routine
// Whenever we need to expand a menu layout or a menu's contents, we'll assign
// it an ID (which the game would normally use as an offset into the $01 bank.
// We're going to assume that low number IDs won't collide with existing menu
// offsets
org $1892f; dw $8000   // redirect main menu options "item, equip, magic, etc."
org $1db47; dw $8002   // redirect the primary text strings in the "treasure" menu
org $1d83e; dw $8004   // redirect the single secondary text string for "take all"
org $1d95f; dw $8006   // redirect the single "Trade" text string in treasure menu
org $187cf; dw $8008   // redirect "Gil" string in main menu
org $187c6; dw $800A   // redirect "TIME" string in main menu
                       //; 800C, 800E, and 8010 are taken by the equip menu's "handedness" strings elsewhere
org $1bd10; dw $8012   // redirect body part strings in equip menu
org $1aed7; dw $8014   // redirect "can't use magic" window + text
org $1b0f0; dw $8016   // redirect "MP Cost" string in main magic menu
org $1afa3; dw $8018   // "White" string in main magic menu
org $1afb7; dw $801A   // "Black" string in main magic menu
org $1afcb; dw $801C   // "Summon" string in main magic menu
org $1afdf; dw $801E   // "Ninjutsu/Incant" string in main magic menu
//org $1afd0; dw $801C   // Another "Summon" string in main magic menu?
org $19f57; dw $8020   // "Items" window and string in main item menu (transition?)
org $1a815; dw $8020   // "Items" window and string in main item menu (static)
org $1a751; dw $8020   // "Items" window and string in main item menu (after using item)
org $1a370; dw $8022   // "No item selected" string in main item menu
org $1a301; dw $8024   // "Can't be used here" string in main item menu
org $1a388; dw $8024   // Another "Items" string in main menu, loaded after "Can't use this" message
org $1a43a; dw $8026   // "Use on whom?" string in main item menu
org $1a7c0; dw $8028   // "Not needed" string for main item menu when using medicine that isn't needed
org $1a6c0; dw $8028   // "Not needed" string for main item menu when using Phoenix Down on a character who isn't dead
org $1b4ae; dw $802A   // "MP Cost" for when using magic on party in main menu
org $1b4b4; dw $802C   // "On whom?" for when using magic on party in main menu
org $1bf82; dw $802E   // "This is a two-handed item" string for equip menu
org $1a99f; dw $8030   // "Stats" in main menu "Stats" transition window
org $1abbd; dw $8032   // The big stats window screen string, with most of the text data
org $1aaea; dw $8034   // "To next level" string in stats window
// 8036, 8038, and 803A are taken by the handedness strings in the stats window
// 803C through and including 8050 are used by character descriptions
org $1d1b1; dw $8052   // "Config" string
org $1d1a5; dw $8054   // Config menu main text strings
org $1d48e; dw $8056   // "Customizer" screen text
org $1d497; dw $8058   // Customizer screen, "Ignore, OK" etc. string
org $1d4a0; dw $8058   //    copy of above
org $1d660; dw $805a   // Battle Selector window and text
org $1d686; dw $805c   // "Controller" string for battle selector menu
org $1cbae; dw $805e   // Save screen "Save" top text
org $1cc13; dw $8060   // "Save cancelled" text
org $1981f; dw $8062   // "Overwrite?" text
org $1982d; dw $8064   // "Yes/no" text
org $1cc34; dw $8066   // "Cancelled" text after choosing not to overwrite a save, doesn't seem to work? menu data is right after the original text data too
org $1cc0e; dw $8068   // "Saved." text
org $1962f; dw $806a   // "New Game" text
org $19827; dw $806c   // "Load this file?" text
org $1984e; dw $806e   // "Gil" on "load this file?" screen
org $1983f; dw $8070   // "TIME" on "load this file?" screen
org $19a53; dw $8072   // "Save" string on save menu, used for "Save 1", "Save 2", etc.
org $1c35a; dw $8074   // "Weapon Shop"
// 8076 is "Armor Shop", 8078 is "Item Shop"
org $1c351; dw $807A   // "Welcome!" shop text
org $1c3ed; dw $807C   // move "Gil" string in Gil owned box in shop menu
org $1c440; dw $807E   // "Which will you buy?" text
org $1c569; dw $8080   // "Gil" next to item prices in shop menu
org $1c74f; dw $8082   // "Thank you!" shop menu window + text
org $1c41f; dw $8084   // "Sorry but your items are full so you can't buy that" text and window
org $1c701; dw $8086   // "You don't have enough money" shop menu text + window
org $1c7df; dw $8088   // "I deal in most things" text + window? in shop menu
org $1c7e5; dw $808A   // "How many?" string for selling menu
org $1c963; dw $808C   // "I can buy that for XXX gil, is that okay?" window + text
org $1db41; dw $808E   // "You can't abandon that key item" window + text in treasure menu
org $1db2f; dw $808E   // Same as above, although there's something weird going on with these two. The window data in this menu line is somehow used by the "Take All   Exit" line too, so they have to share the same box
org $1cd9c; dw $8090   // "Yo, whatcha want?" text from start of Fat Chocobo menu
org $1cd97; dw $8092   // "Don't play the flute in a place like this" line from Fat Chocobo
org $1cd81; dw $8094   // "Fat Chocobo" and fat chocobo menu strings
org $1ce85; dw $8096   // "Whatcha gonna leave with me?" fat chocobo string
org $1d06c; dw $8098   // "What item do you want? fat chocobo string
org $1cff2; dw $809A   // "Can't deposit any more items" fat chocobo string
org $1d037; dw $809C   // "Your inventory is full" fat chocobo string
org $1ba48; dw $809E   // "Changing your name?" Namingway text + setup data for the "Change    Don't Change" window
org $1ba51; dw $80A0   // "Change    Don't Change" Namingway text only
org $1bacb; dw $80A2   // "Guess it's better that way" line from Namingway when exiting
org $1bb1f; dw $80A4   // "Change whose name?" string
org $19e69; dw $80A6   // "Katakana   Hiragana   ABC   End" name change menu string
org $18b2b; dw $80A8   // "KOed" string in status menu
// 80AA is Treasure symbol string in main menu
// 80AC is "Gil" string for main menu (if not including treasure counter ASM)
// 80AE is "Time" string for main menu (if not including treasure counter ASM)
org $1a5d7; dw $80B0   // "Inffective." when you try an item on a dead party member




//====================================================================
// NEW CUSTOM CODE GOES HERE
//====================================================================
org $2BF800
db "****************NEW CODE: MENU-RELATED IMPROVEMENTS"


//-----------------------------------------------------------------------------
mainmenu_save_highlight:
lda #$24
sta $ca31
sta $ca33
sta $ca35
sta $ca37
sta $ca39
sta $ca3b
rtl


//-----------------------------------------------------------------------------
item_description_handler:
sta $45
rep #$20
txa
asl
tax
lda $2AC040,x
adc #$C280
tax
sep #$20
rtl


//-----------------------------------------------------------------------------
loadwindow:
phx
pld

//-----------------------------------------------------------------------------
// our manual repointing stuff happens here
// if the offset in Y is a low number, we'll treat it as a custom ID
// number to easily redirect to the appropriate new data location

cpy #$8200 // check if custom window data pointer
beq +
bcs +

lda #$2f
pha
plb

rep #$20
tya
adc #$0030
tay
lda $0000,y
tay
sep #$20

+
cpy #$9F00  // check if custom window data
bcc +


//-----------------------------------------------------------------------------

lda #$01   // do normal stuff if not one of the above diversions
pha
plb
jmp lw_exit

+
lda #$2f
pha
plb

lw_exit:
rtl


//-----------------------------------------------------------------------------

custom_menu_text_reader:
cpy #$9F00
bcc +

iny
iny
iny
iny
jmp cmtr_exit

+
pha
phb

lda #$2f
pha
plb

rep #$20
tya
adc #$0030
tay
lda $0000,y
tay
iny
iny
iny
iny
sep #$20

plb
pla

cmtr_exit:
rtl


//-----------------------------------------------------------------------------
custom_menu_window_reader:
phb

cpy #$9F00
bcc +

pla
phy
pha
lda #$01
pha
plb

rep #$20
jmp cmwr_exit


+
lda #$2f
pha
plb

rep #$20
tya
adc #$0030
tay
lda $0000,y
tay
sep #$20

pla
phy
pha

cmwr_exit:
jml $0180dd


//-----------------------------------------------------------------------------
custom_menu_text_reader2:
cpy #$8200
bcc +

phx  // original code
pld

phx  // easy way to get the high byte of X into A
pla
pla
plx
pha
jmp cmtr2_exit

+
plx

lda #$2f
pha
plb
pha

rep #$20
tya
adc #$0030
tay
lda $0000,y
tay
sep #$20


cmtr2_exit:
plb
jml $182d9


//-----------------------------------------------------------------------------
custom_menu_text_reader3:
rep #$20

cpy #$8200
bcc +
jmp cmtr3_exit

+
sep #$20
lda #$2f
pha
plb
rep #$20
tya
adc #$0030
tay
lda $0000,y
tay

cmtr3_exit:
txa
clc
rtl

//-----------------------------------------------------------------------------
// 01 = left
// 10 = right
// 11 = ambi

expand_equip_handedness:
lsr
lsr
lsr
lsr
lsr
sta $45
rtl


//-----------------------------------------------------------------------------
numeral_print_modification:
lda $5a
cmp #$ff    // we're going to not print the 4th digit if it's blank
beq +

sta $0000,y

+
lda $5b
cmp #$ff    // don't print if we're doing the 3rd digit and it's blank
beq +

sta $0002,y

+
lda $5d
sta $0004,y
lda $5e
sta $0006,y
rtl


//-----------------------------------------------------------------------------
customizer_cursor_calculator:
phx

rep #$20
and #$00ff
tax
sep #$20
lda customizer_cursor_y_pos,x
plx
rtl

customizer_cursor_y_pos:
db $3a,$4a,$5a,$72,$8a,$aa


//-----------------------------------------------------------------------------
shop_cursor_calculator:
phx
rep #$20
and #$00ff
tax
sep #$20
lda shop_cursor_x_pos,x
plx
rtl

shop_cursor_x_pos:
db $08,$28,$50


//-----------------------------------------------------------------------------
controller_choice_formatter1:
rep #$20
pha
tya
clc
adc #$0008
tay
pla
sep #$20
rtl


//-----------------------------------------------------------------------------
controller_choice_formatter2:
rep #$20
pha
tya
clc
adc #$0004
tay
pla
sep #$20
rtl


//-----------------------------------------------------------------------------
display_item_being_sold:
stz $db
lda $5d
ldy #$02d4

sta $43
rep #$20
lda $29
clc
adc #$0040
sta $1d
lda $43
asl
asl
asl
asl
asl
tax
jsl long_item_strlen

sep #$20
lda $2B8030,x
cmp #$B2
bne +

inx
iny
iny

+
lda #$20
sta $45

-
lda $2B8030,x
cmp #$ff
beq +
cmp #$00
beq +

xba
lda #$ff
sta ($29),y
xba
sta ($1d),y
inx
iny
lda $db
ora $34
sta ($29),y
sta ($1d),y
iny
dec $45
bne -

+

iny
iny
iny
iny

rep #$20
tya
clc
adc #$0040
tay
sep #$20

rtl


//-----------------------------------------------------------------------------
long_item_strlen:
phx         // save value of X
rep #$20
lda $00     // save what's in $00
pha
lda $02     // save what's in $02
pha
sep #$20
ldy #$0000  // initialize our length count

-
lda $2B8030,x
cmp #$ff
beq +
cmp #$00
beq +
inx
iny
cpy #18     // I've made it so the expanded strings can only be 18 letters max, could be moved to 32 if needed
beq +
jmp -

+
rep #$20
lda #$0000
tya         // A now holds the length of the expanded string!
tax         // and so does X

// now that we know the length of the string, we need to calculate how to center it
inc         // add 4 to the length to compensate for " x##"
inc
inc
inc

sta $0000
lda #$0016
sec
sbc $0000
lsr          // (22 - length of string) / 2
asl          // multiply by 2 because 2 bytes per tile

adc #$02c8
tay
pha
txa
inc
inc
asl
sta $0000
tya
clc
adc $0000
adc #$003e
tay

sep #$20
lda #$93      // Insert the multiplication symbol
sta ($29),y
lda #$FF
sta ($1d),y

rep #$20
pla
tay           // y has the starting address to write at again

// restore stuff to how we left it
pla
sta $02
pla
sta $00
sep #$20
plx
rtl       


//-----------------------------------------------------------------------------
loadshortspellname_menu1:
lda $2ea606     // the value at this address will be 0x39 if tsushiy's patch has been applied
cmp #$39
bne +

phx             // if we're here, we're using tsushiy's custom enemy patch, so use custom strings
tyx
lda $28a2d0,x
plx
iny
rtl

+
phx             // if we're here, we're using the original patch, so use original strings
tyx
lda $28a0f0,x
plx
iny
rtl


//-----------------------------------------------------------------------------
loadshortspellname_menu2b:
lda $2ea606     // the value at this address will be 0x39 if tsushiy's patch has been applied
cmp #$39
bne +

phx             // if we're here, we're using tsushiy's custom enemy patch, so use custom strings
tyx
lda $28a2d0,x
plx
rtl

+
phx             // if we're here, we're using the original patch, so use original strings
tyx
lda $28a0f0,x
plx
rtl


//-----------------------------------------------------------------------------
adjust_magic_category_cursor:
sbc #$01        // adjust y-pos by subtracting 1 for better alignment
sta $46
lda #$07        // adjust x-pos to look a tad better
rtl




//==================================================================================
// New code added to original program banks
// This code is used to do things that would be hard/impossible by expanding into
// new banks, but there's very little room to maneuver in here
// The roughly free area (assumedly?) begins at $1ff48 and ends at $1ffff
//==================================================================================

//-------------------------------------------------------------------------------
org $1ff50
add_character_description:
pha
lda ($60)
rep #$20
and #$003F
bne +

jmp add_desc_end
ldy #$001d
jmp $1aa95

+
dec
tax
sep #$20
lda $018457,x
rep #$20
asl
adc #$803C
tay
sep #$20
jsr $8301

add_desc_end:
pla
xba
ldy #$001d
jmp $1aa95


//-----------------------------------------------------------------------------
loadshortspellname_menu2a:
jsl loadshortspellname_menu2b
jmp $1b34c
